#
# -*- coding: utf-8 -*-

'''XSLT abstraction layer
'''

import logging
log = logging.getLogger("biocase.tools")


def transformXML(xmlString, xslLoc, paras={}):
    import lxml

    # remove leading "file://"
    xslLoc = xslLoc[7:]
    styledoc = libxml2.parseFile(xslLoc)
    style = libxslt.parseStylesheetDoc(styledoc)
    log.info("APPLY STYLESHEET %s" % xslLoc)
    try:
        # convert paras
        xsltParas = {}
        for p, val in list(paras.items()):
            xsltParas[p] = "'%s'" % str(val)
        resultDoc = style.applyStylesheet(libxml2.parseDoc(xmlString), xsltParas)
        result = style.saveResultToString(resultDoc)
    except:
        log.exception("ERROR when applying the stylesheet")
        result = 'XSLT NOT WORKING !!!'

    return result
