# -*- coding: utf8 -*-
'''DB MODULE - MS Access
******************************
***  DB MODULE - MS Access
******************************
$RCSfile: dbmod_odbc_access.py,v $
$Revision: 1627 $
$Author: j.holetschek $
$Date: 2021-05-25 15:06:16 +0200 (Di, 25. Mai 2021) $

The biocase.wrapper database module to access MS Access databases.
You will need the pyODBC module to connect to a ODBC source.
'''
from biocase.wrapper.dbmod.dbmod_odbc import DBmodule

import logging
log = logging.getLogger("pywrapper.dbmod")


class DBmodule(DBmodule):
    __dbmod__ = 'MS Access DB module using pyODBC'

    def getTables(self):
        try:
            obj = self.conn.cursor()
            return [t[2].strip("'") for t in obj.tables() if t[3] in ['TABLE', 'VIEW']]
        except:
            log.exception("Couldn't retrieve table info")
