# -*- coding: utf8 -*-
'''
SHARED FUNCTIONS MODULE
*****************************
***  SHARED FUNCTIONS MODULE
*****************************
$RCSfile: static_functions.py,v $
$Revision: 1627 $
$Author: j.holetschek $
$Date: 2021-05-25 15:06:16 +0200 (Di, 25. Mai 2021) $

general functions used in different biocase.wrapper modules
'''


import os

import logging
log = logging.getLogger("pywrapper.functions")

# ------------------------------------------------------------------------------------
def icode(x):
    return str.join( ["%03i"%(ord(c)*3+73) for c in x], "" )

# ------------------------------------------------------------------------------------
def ocode(x):
    if type(x) == type(1):
        return x
    else:
        return x.decode('uu_codec')

# ------------------------------------------------------------------------------------
def getTmp(x):
    from biocase.wrapper.sql.operators     import comparisonOperator
    return comparisonOperator('equals', 'tmp', x)
    

# ------------------------------------------------------------------------------------
magicPias = {'430385406169388418169421385376169418376433388376418421169430406400364403169406403169376364415421385262':('begin 666 <data>\n#4&EA\n \nend\n',1973,'begin 666 <data>\n*,3DW,RTP.2TR,0  \n \nend\n'),
    '430385406169388418169421385376169400406418421169367376364424421388379424397169430406400364403169406403169376364415421385262':('begin 666 <data>\n#4&EA\n \nend\n',1973,'begin 666 <data>\n*,3DW,RTP.2TR,0  \n \nend\n'),
    '430385388370385169367364403373169430388397397169418364427376169421385376169430406415397373262':('begin 666 <data>\n65&AE($-E;&QO<&AA;F4@4W5C:V5R<P  \n \nend\n',666,'begin 666 <data>\n$,3DY,P  \n \nend\n'),
    '382388400400376169415406370394169403169415406397397172':('begin 666 <data>\n65&AE($-E;&QO<&AA;F4@4W5C:V5R<P  \n \nend\n',666,'begin 666 <data>\n$,3DY,P  \n \nend\n'),
    '430385406169388418169421385376169367376418421169397406406394388403382169430406400364403169406403169376364415421385262':('begin 666 <data>\n#4&EA\n \nend\n',1973,'begin 666 <data>\n*,3DW,RTP.2TR,0  \n \nend\n'),
    '430385406169388418169421385376169367376418421169397406406394388403382169400364403169406403169376364415421385262':('begin 666 <data>\n*4VER(%=I>&YE<@  \n \nend\n',1973,'begin 666 <data>\n*,3DW,RTP,2TS,0  \n \nend\n'),
    '430385406169388418169421385376169370406406397376418421169382424436169406403169376364415421385262':('begin 666 <data>\n*4VER(%=I>&YE<@  \n \nend\n',1973,'begin 666 <data>\n*,3DW,RTP,2TS,0  \n \nend\n')
}

def getData(x):
    if x in magicPias:
        return magicPias[x]
    else:
        return None



# ------------------------------------------------------------------------------------
def getAbsoluteCWDirectory():
    '''return the absolute path of the script directory . On IIS, set it to the script directory and not to the cwd which is the root directory of the webserver.'''
    # default
    cwd = os.getcwd()
    return cwd
    # check if its an IIS
    if 'PATH_TRANSLATED' in os.environ:
        cwd = os.path.split(os.environ['PATH_TRANSLATED'])[0]
    # check if its an Apache
    elif 'SCRIPT_FILENAME' in os.environ:
        cwd = os.path.split(os.environ['SCRIPT_FILENAME'])[0]
    # try something else
    elif 'SCRIPT_NAME' in os.environ or 'REQUEST_URI' in os.environ:
        try:
            if 'SCRIPT_NAME' in os.environ:
                scriptPath = os.environ['SCRIPT_NAME']
            else:
                scriptPath = os.environ['REQUEST_URI']
            scriptPathList = scriptPath.split('/')[1:-1]
            scriptPath = ''
            for p in scriptPathList:
                scriptPath = os.path.join(scriptPath, p)
            # test if scriptPath is already part of the cwd (as it is with Apache)
            if len(cwd) > len(scriptPath) and scriptPath == cwd[- len(scriptPath):]:
                pass
            else:
                cwd = os.path.join(cwd, scriptPath)
        except:
            log + (1, 'Problems finding the right filepaths on your server. Please adjust your virtual server directories so that the current working directory is pointing to the dbwrapper.py file of your database. The current working directory used is "%s"' %cwd)
    # no idea
    else:
        log + (1, 'Problems finding the right filepaths on your server. Please adjust your virtual server directories so that the current working directory is pointing to the dbwrapper.py file of your database. The current working directory used is "%s"' %cwd)
    return cwd


